#ifndef FILE_H
#define FILE_H

// INCLUDES

#include "sudoku.h"


// FUNCTIONS

/**
 * Save the menu settings to a file.
 */
char saveSettings(int difficulty, int size, int showTime);

/**
 * Load the menu settings from a file to the parameters.
 */
char loadSettings(int *difficulty, int *size, int *showTime);

/**
 * Save the sudoku field to a file the user has selected. Only use the neccessary
 * space, as defined in size. The fileID is defined by the size.
 *
 * @param field The sudoku field
 * @param size The size of the sudoku field (2 for 4x4, 3 for 9x9, ...)
 */
char saveSudoku(Field field, char size);

/**
 * Load the sudoku field from a selected file and save it to the parameter
 * field. Only allow loadin from the correct fileID.
 *
 * @param field The sudoku field
 * @param size The size of the sudoku field (2 for 4x4, 3 for 9x9, ...)
 */
char loadSudoku(Field field, char size);

#endif // FILE_H
