#include "sudoku.h"
#include "io.h"
#include "menu.h"
#include "game.h"
#include "time.h"
#include "generate.h"

#include "file.h"

int _main()
{
    //Field test;
    //Field a = {
    ////{8,3,0,2,1,9,0,5,0},
    ////{0,0,0,4,0,0,0,0,0},
    ////{0,9,0,0,8,7,0,1,0},
    ////{0,2,0,1,0,0,0,4,5},
    ////{5,8,7,0,0,0,2,0,1},
    ////{9,4,0,0,0,2,0,8,0},
    ////{0,0,0,8,3,5,0,9,0},
    ////{3,0,0,0,0,1,0,0,0},
    ////{0,1,0,6,0,4,0,0,3}
    //{3,0,0,0,0,8,0,0,9},
    //{0,0,0,2,0,0,7,1,0},
    //{0,0,0,0,4,0,6,0,3},
    //{0,4,3,0,2,0,0,0,1},
    //{0,0,0,0,0,9,8,0,4},
    //{0,0,0,0,7,0,0,0,0},
    //{0,0,6,0,0,1,0,0,0},
    //{4,0,0,3,0,0,9,0,0},
    //{0,7,5,9,6,0,0,0,0}
    //};

    //if (!saveSudoku(a, 3)) return 0;

    //if (!loadSudoku(test, 3)) return 0;

    //int x, y;
    //for (y = 0; y < 9; ++y)
    //{
    //    for (x = 0; x < 9; ++x)
    //        printf("%d ", test[y][x]);
    //    printf("\n");
    //}
    //ngetchx();


    //int *ptr;
    //while (TRUE)
    //{
    //    ptr = malloc(81 * sizeof(int));
    //    free(ptr);
    //}

    //Field test = {
    ////{8,3,0,2,1,9,0,5,0},
    ////{0,0,0,4,0,0,0,0,0},
    ////{0,9,0,0,8,7,0,1,0},
    ////{0,2,0,1,0,0,0,4,5},
    ////{5,8,7,0,0,0,2,0,1},
    ////{9,4,0,0,0,2,0,8,0},
    ////{0,0,0,8,3,5,0,9,0},
    ////{3,0,0,0,0,1,0,0,0},
    ////{0,1,0,6,0,4,0,0,3}
    //{3,0,0,0,0,8,0,0,9},
    //{0,0,0,2,0,0,7,1,0},
    //{0,0,0,0,4,0,6,0,3},
    //{0,4,3,0,2,0,0,0,1},
    //{0,0,0,0,0,9,8,0,4},
    //{0,0,0,0,7,0,0,0,0},
    //{0,0,6,0,0,1,0,0,0},
    //{4,0,0,3,0,0,9,0,0},
    //{0,7,5,9,6,0,0,0,0}
    //};
    //printf("%d", getNrSolutions(test));
    //ngetchx();
    //return 0;

    //Field f;
    //generateSudoku(f);

    //printField(f);
    //return 0;

    //int x, y;
    //int cnt;
    //Field f;
    //while (TRUE)
    //{
    //    cnt = 0;
    //    generateSudoku(f);
    //    printf("aba\naba");
    //    makeSudokuHarder(f, 30);
    //    for (y = 0; y < 9; ++y)
    //        for (x = 0; y < 9; ++x)
    //            if (f[y][x] > 0)
    //                ++cnt;
    //    printf("%d\n", cnt);
    //}

    if (!GrayOn()) return 1; // enable the grayscale graphics subsystem

    initTimer();

    int difficulty = 0;
    int size = 1;
    int showTime = 1;

    int realSize = 0;

    loadSettings(&difficulty, &size, &showTime);

    while (TRUE)
    {
        // esc or quit were pressed, deinit and leave game
        if (!mainMenu(&difficulty, &size, &showTime))
        {
            saveSettings(difficulty, size, showTime);

            GrayOff(); // disable before exiting
            deinitTimer();
            return 0;
        }

        switch (size) // transform size
        {
        case SIZE_4x4:
            realSize = 2;
            break;
        case SIZE_9x9:
            realSize = 3;
            break;
        case SIZE_16x16:
            realSize = 4;
            break;
        }

        initialize(realSize);

        if (difficulty == DIFFICULTY_ENTER) // user enters own
        {
            drawGame();
            enterField();
            if (!checkField())
                continue; // return to main menu on invalid field
        }
        else if (difficulty == DIFFICULTY_LOAD) // load from file
        {
            Field f;

            if (!loadSudoku(f, realSize))
                continue; // couldn't load
            fillField(f, 1);
            drawGame();
        }
        else
        {
            if (size != SIZE_9x9)
            {
                popup("Generation works only on 9x9");
                continue;
            }

            message("GENERATING");

            Field f;

            generateSudoku(f);

            switch (difficulty)
            {
            case 0:
                makeSudokuEasier(f, 20);
                break;
            case 1:
                makeSudokuEasier(f, 16);
                break;
            case 2:
                makeSudokuEasier(f, 12);
                break;
            case 3:
                makeSudokuEasier(f, 8);
                break;
            case 4:
                makeSudokuEasier(f, 4);
                break;
            case 5:
                break;
            case 6:
                makeSudokuHarder(f, 30);
                break;
            }

            fillField(f, 1);
            drawGame();
        }

        playGame(HAS_MENU, showTime);
    }
}
