#include "time.h"

volatile INT_HANDLER oldInt5 = NULL;

// volatile tells the compiler not to optimize (compiler doesn't know
// interrupts and could therefore break our program)
volatile int mSeconds50, // nearly 50ms (1000/19)
             seconds,
             minutes,
             hours,
             resetTime, // reset
             running; // running or stopped

DEFINE_INT_HANDLER (timeInt5)
{
    if (resetTime)
        mSeconds50 = seconds = minutes = hours = resetTime = 0;

    else if (running) // count and display
    {
        // start at 0 (starting with mSeconds50 == 19 would be at 1)
        //if (!mSeconds50) printTime();

        if (++mSeconds50 == 19)
        {
            mSeconds50 = 0;

            if (++seconds == 60)
            {
                seconds = 0;

                if (++minutes == 60)
                {
                    minutes = 0;

                    if (++hours == 24)
                        hours = 0;
                }
            }
        }
    }

    ExecuteHandler(oldInt5);
}

void getTime(char *str)
{
    sprintf(str, "%02d:%02d:%02d",hours,minutes,seconds);
}

void printTime()
{
    // display only one time a second
    char s[30];
    getTime(s);
    write(191, 119, s, A_REPLACE, F_6x8);
}

void initTimer()
{
    mSeconds50 = seconds = minutes = hours = running = 0;
    resetTimer();
    oldInt5 = GetIntVec(AUTO_INT_5); // backup
    SetIntVec(AUTO_INT_5, timeInt5); // set new
}

void deinitTimer()
{
    SetIntVec(AUTO_INT_5, oldInt5); // restore
}

void startTimer()
{
    running = TRUE;
}

void stopTimer()
{
    running = FALSE;
}

void resetTimer()
{
    resetTime = TRUE;
}
